原题链接:http://acm.hdu.edu.cn/showproblem.php?pid=2577
Problem Description
Pirates have finished developing the typing software. He called Cathy to test his typing software. She is good at thinking. After testing for several days, she finds that if she types a string by some ways, she will type the key at least. But she has a bad habit that if the caps lock is on, she must turn off it, after she finishes typing. Now she wants to know the smallest times of typing the key to finish typing a string.
问题描述
海盗已经完成了打字软件的开发。
他打电话给凯茜测试他的打字软件。
她善于思考。
经过几天的测试,她发现如果她通过某种方式键入字符串,她至少会输入密钥。
但她有一个坏习惯,即如果打开大写锁定,她必须在完成打字后关掉它。
现在,她想知道键入键的最小时间,以完成键入字符串。
Input
The first line is an integer t (t<=100), which is the number of test case in the input file. For each test case, there is only one string which consists of lowercase letter and upper case letter. The length of the string is at most 100.
输入
第一行是整数t(t <= 100),它是输入文件中的测试用例数。
对于每个测试用例,只有一个字符串由小写字母和大写字母组成。
字符串的长度最多为100。
Output
For each test case, you must output the smallest times of typing the key to finish typing this string.
产量
对于每个测试用例,必须输出键入键的最小次数才能完成键入此字符串。
Sample Input
3
Pirates
HDUacm
HDUACM
Sample Output
8
8
8
Hint
The string “Pirates”, can type this way, Shift, p, i, r, a, t, e, s, the answer is 8.
The string “HDUacm”, can type this way, Caps lock, h, d, u, Caps lock, a, c, m, the answer is 8
The string “HDUACM”, can type this way Caps lock h, d, u, a, c, m, Caps lock, the answer is 8
暗示
字符串“Pirates”,可以这样输入,Shift,p,i,r,a,t,e,s,答案是8。
字符串“HDUacm”,可以这样输入,大写锁定,h,d,u,大写锁定,a,c,m,答案是8
字符串“HDUACM”,可以这样输入大写锁定h,d,u,a,c,m,大写锁定,答案是8
个人思路:用背包的时候记得。输入上一个字母键盘锁状态和输入这个字母键盘锁状态同为小写的时候,输入一个大写字母,最少步骤只需要两步,也就是shift+输入字母,而不是CapsLock+输入字母+CapsLock的三步。
ac代码:
#include <cstdio>
#include <cstring>
#include <algorithm>
#include<iostream>
using namespace std;
int const MAX = 105;
char s[MAX];
int dp[MAX][2]; //采用一个二重背包,用一层来储存 capslock 状态
bool judge(char ch)
{
if (ch >= 'A' && ch <= 'Z')
return true;
return false;
}
int main()
{
int T;
cin >> T;
while (T--)
{
scanf("%s", s + 1); //从s[1]开始存数据。输入一串字母
int len = strlen(s + 1); //获取这串字母
memset(dp, 0, sizeof(dp)); //清空背包
dp[0][1] = 1; //这里赋值dp[0][1]=1,而且dp[0][0]没有赋值,所以dp[0][0]=0
for (int i = 1; i <= len; i++)
{
if (judge(s[i])) //如果s[i]是大写字母则执行
{
dp[i][1] = min(dp[i - 1][1] + 1, dp[i - 1][0] + 2); //本次capslock状态为开。若前一次capslock状态为开,则输入字母;1个操作;若前一次capslock状态为关,则开capslock,输入字母,2个操作。
dp[i][0] = min(dp[i - 1][1] + 2, dp[i - 1][0] + 2); //本次capslock状态为关。若前一次capslock状态为开,则输入字母,关capslock,2个操作;若前一次capslock状态为关,则为shitf+输入字母2个操作。
}
else //如果s[i]是小写字母则执行
{
dp[i][1] = dp[i - 1][1] + 2; //上一个状态开。本状态开,操作为,关capslock,输入字母,2个操作
dp[i][0] = dp[i - 1][0] + 1; //上一个状态关。本状态关,操作为,输入字母
}
}
printf("%d\n", min(dp[len][0], dp[len][1] + 1)); //最终长度,注意键盘锁状态要不要再加一步操作
}
}